// Code generated by "enumer -type=Version -json -text -yaml -sql"; DO NOT EDIT.

//
package versions

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _VersionName = "OneTwoThreeAll"

var _VersionIndex = [...]uint8{0, 3, 6, 11, 14}

func (i Version) String() string {
	i -= 1
	if i < 0 || i >= Version(len(_VersionIndex)-1) {
		return fmt.Sprintf("Version(%d)", i+1)
	}
	return _VersionName[_VersionIndex[i]:_VersionIndex[i+1]]
}

var _VersionValues = []Version{1, 2, 3, 4}

var _VersionNameToValueMap = map[string]Version{
	_VersionName[0:3]:   1,
	_VersionName[3:6]:   2,
	_VersionName[6:11]:  3,
	_VersionName[11:14]: 4,
}

// VersionString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func VersionString(s string) (Version, error) {
	if val, ok := _VersionNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to Version values", s)
}

// VersionValues returns all values of the enum
func VersionValues() []Version {
	return _VersionValues
}

// IsAVersion returns "true" if the value is listed in the enum definition. "false" otherwise
func (i Version) IsAVersion() bool {
	for _, v := range _VersionValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for Version
func (i Version) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for Version
func (i *Version) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("Version should be a string, got %s", data)
	}

	var err error
	*i, err = VersionString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for Version
func (i Version) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for Version
func (i *Version) UnmarshalText(text []byte) error {
	var err error
	*i, err = VersionString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for Version
func (i Version) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for Version
func (i *Version) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = VersionString(s)
	return err
}

func (i Version) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *Version) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := VersionString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
